#ifndef MAIN_H
#define MAIN_H

#include <ktmainwindow.h>
#include <kaccel.h>

#include "dialogs.h"

class Interface;

class MainWidget : public KTMainWindow
{
 Q_OBJECT

 public:
    MainWidget();
    ~MainWidget() { delete kacc; }

 private slots:
	void showHighScores() { WHighScores(this); }
	void toggleMenu()     { _toggleMenu(FALSE); }
	void print()          { debug("not implemented"); }
	void toggleShadow()   { _toggleShadow(FALSE); }
	void toggleShowNext() { _toggleShowNext(FALSE); }
	void quit();

 protected:
	bool eventFilter(QObject *, QEvent *);
	
 private:
	KMenuBar   *menu;
	QPopupMenu *popup, *options;
	int        toggleId, shadowId, showNextId;
	KAccel     *kacc;
	Interface  *inter;
	
	void _toggleMenu(bool first);
	void _toggleShadow(bool first);
	void _toggleShowNext(bool first);
};

#endif // MAIN_H
