#include "types.h"

QDataStream &operator <<(QDataStream &s, const ClientPlayData &d)
  { s << d.height << d.gift << d.end; return s; }
QDataStream &operator >>(QDataStream &s, ClientPlayData &d)
  { s >> d.height >> d.gift >> d.end; return s; }

QDataStream &operator <<(QDataStream &s, const GameOverItem &d)
  { s << d.score << d.level; return s; }
QDataStream &operator >>(QDataStream &s, GameOverItem &d)
  { s >> d.score >> d.level; return s; }

QDataStream &operator <<(QDataStream &s, const GameOverData &d)
  { s << (Q_UINT8)d.size();
	for (uint i=0; i<d.size(); i++) s << d[i];
	return s; }
QDataStream &operator >>(QDataStream &s, GameOverData &d)
  { Q_UINT8 n; s >> n;
	d.resize(n); for (uint i=0; i<n; i++) s >> d[i];
	return s; }

QDataStream &operator <<(QDataStream &s, const ServerPlayData &d)
  { s << d.prevHeight << d.nextHeight << d.gift; return s; }
QDataStream &operator >>(QDataStream &s, ServerPlayData &d)
  { s >> d.prevHeight >> d.nextHeight >> d.gift; return s; }

QDataStream &operator <<(QDataStream &s, const ServerInitData &d)
{ s << d.seed << d.nextName << d.prevName << d.name; return s; }
QDataStream &operator >>(QDataStream &s, ServerInitData &d)
{ s >> d.seed >> d.nextName >> d.prevName >> d.name; return s; }
