#ifndef TYPES_H
#define TYPES_H

#include <qdatastream.h>

typedef struct { Q_UINT8 height, gift, end; } ClientPlayData;
QDataStream &operator <<(QDataStream &s, const ClientPlayData &d);
QDataStream &operator >>(QDataStream &s, ClientPlayData &d);

typedef struct { Q_UINT32 score; Q_UINT8 level; } GameOverItem;
QDataStream &operator <<(QDataStream &s, const GameOverItem &d);
QDataStream &operator >>(QDataStream &s, GameOverItem &d);

class GameOverData : public QArray<GameOverItem>
{
 public:
	GameOverData(uint nb = 0) : QArray<GameOverItem>(nb) {}
};
QDataStream &operator <<(QDataStream &s, const GameOverData &d);
QDataStream &operator >>(QDataStream &s, GameOverData &d);

typedef struct { Q_UINT8 prevHeight, nextHeight, gift; } ServerPlayData;
QDataStream &operator <<(QDataStream &s, const ServerPlayData &d);
QDataStream &operator >>(QDataStream &s, ServerPlayData &d);

typedef struct {
	QString prevName, nextName, name; Q_UINT32 seed;
} ServerInitData;
QDataStream &operator <<(QDataStream &s, const ServerInitData &d);
QDataStream &operator >>(QDataStream &s, ServerInitData &d);

#endif
